<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.bpel.ui.InstanceManagementServiceClient" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.InstanceInfoType" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.InstanceDeleteStatusType" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.Action_type1" %>
<%@ page import="org.apache.http.HttpStatus" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<carbon:breadcrumb
        label="instance.details"
        resourceBundle="org.wso2.carbon.bpel.ui.i18n.Resources"
        topPage="false"
        request="<%=request%>"/>
<fmt:bundle basename="org.wso2.carbon.bpel.ui.i18n.Resources">
    <%
        String iid = (String) request.getParameter("iid");
        String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
        ConfigurationContext configContext =
                (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

        InstanceManagementServiceClient client;
        InstanceInfoType instance;

        try {
            client = new InstanceManagementServiceClient(cookie, backendServerURL, configContext);
        } catch (Exception e) {
            response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
            CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
    %>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
    <%
            return;
        }

        String operation = (String) request.getParameter("operation");
        if (operation != null) {
            if (operation.toLowerCase().equals("suspend")) {
                if (iid != null && iid.length() > 0) {
                    try {
                        InstanceInfoType instanceReturned = client.suspendInstance(Long.parseLong(iid.trim()));
                        if (instanceReturned == null || !(Long.parseLong(instanceReturned.getIid()) == Long.parseLong(iid.trim()))) {
    %>
    <script type="text/javascript">
        jQuery(document).ready(function() {
            CARBON.showErrorDialog("<fmt:message key="error.suspending.instance"/> <%=iid%>!");
        });
    </script>
    <%
        }
    } catch (Exception e) {
            response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
    %>
    <script type="text/javascript">
        location.href = "../admin/error.jsp";
    </script>
    <%
                return;
            }
        }
    } else if (operation.toLowerCase().equals("resume")) {
        if (iid != null && iid.length() > 0) {
            try {
                InstanceInfoType instanceReturned = client.resumeInstance(Long.parseLong(iid.trim()));
                if (instanceReturned == null || !(Long.parseLong(instanceReturned.getIid()) == Long.parseLong(iid.trim()))) {
    %>
    <script type="text/javascript">
        jQuery(document).ready(function() {
            CARBON.showErrorDialog("<fmt:message key="error.resuming.instance"/> <%=iid%>!");
        });
    </script>
    <%
        }
    } catch (Exception e) {
            response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
    %>
    <script type="text/javascript">
        location.href = "../admin/error.jsp";
    </script>
    <%
                return;
            }
        }
    } else if (operation.toLowerCase().equals("recover")) {
        String aid = request.getParameter("aid");
        String action = request.getParameter("action");
        if (iid != null && iid.length() > 0 && aid != null && aid.length() > 0 && action != null && action.length() > 0) {
            try {
                InstanceInfoType instanceReturned = null;
                if (action.equals("cancel")) {
                    instanceReturned = client.recoverActivity(Long.parseLong(iid.trim()), Long.parseLong(aid.trim()), Action_type1.cancel);
                } else if (action.equals("retry")) {
                    instanceReturned = client.recoverActivity(Long.parseLong(iid.trim()), Long.parseLong(aid.trim()), Action_type1.retry);    
                }
                if (instanceReturned == null || !(Long.parseLong(instanceReturned.getIid()) == Long.parseLong(iid.trim()))) {
    %>
    <script type="text/javascript">
        jQuery(document).ready(function() {
            CARBON.showErrorDialog("<fmt:message key="error.recovering.activity"/> <%=iid%>!");
        });
    </script>
    <%
        }
    } catch (Exception e) {
            response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
    %>
    <script type="text/javascript">
        location.href = "../admin/error.jsp";
    </script>
    <%
                return;
            }
        }
    } else if (operation.toLowerCase().equals("terminate")) {
        if (iid != null && iid.length() > 0) {
            try {
                InstanceInfoType instanceReturned = client.terminateInstance(Long.parseLong(iid.trim()));
                if (instanceReturned == null || !(Long.parseLong(instanceReturned.getIid()) == Long.parseLong(iid.trim()))) {
    %>
    <script type="text/javascript">
        jQuery(document).ready(function() {
            CARBON.showErrorDialog("<fmt:message key="error.terminating.instance"/> <%=iid%>!");
        });
    </script>
    <%
        }
    } catch (Exception e) {
            response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
    %>
    <script type="text/javascript">
        location.href = "../admin/error.jsp";
    </script>
    <%
                        return;
                    }
                }
            }
        }
        
        try {
            instance = client.getInstanceInfo(Long.parseLong(iid));
        } catch (Exception e) {
            response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
            CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
    %>
    <script type="text/javascript">
        location.href = "../admin/error.jsp";
    </script>
    <%
            return;
        }
    %>

    <div id="middle">
        <style>
            a.icon-link {
                float: none;
            }
        </style>
        <link media="all" type="text/css" rel="stylesheet" href="css/SyntaxHighlighter.css">
        <link media="all" type="text/css" rel="stylesheet" href="css/xmlverbatim.css">
        <script type="text/javascript" src="js/bpel-main.js"></script>
        <script type="text/javascript">
            var intervalObject;

            BPEL.instance.loadDynamicProps = function() {
                var url = "instance_info-ajaxprocessor.jsp?iid=<%=iid%>";
                jQuery("#workArea").load(url, function(resText, status, res) {
                    if (status != "success") {
                        if (intervalObject) {
                            clearInterval(intervalObject);
                        }                        
                        return;
                    }
                    alternateTableRows('tableActivityInfo', 'tableEvenRow', 'tableOddRow');
                    alternateTableRows('tableRootScope', 'tableEvenRow', 'tableOddRow');
                    alternateTableRows('instanceStatic', 'tableEvenRow', 'tableOddRow');
                });
            }

            BPEL.instance.deleteIns = function(iid) {

                /*  TODO fix deleting instances asynchronously 
                function handleYes() {
                    clearInterval(intervalObject);
                    var filterVal = "iid=" + iid;
                    jQuery.get("delete_instances-ajaxprocessor.jsp", {filter: filterVal}, function(data) {
                        CARBON.showInfoDialog(data, function(){window.location.href = "instance_list.jsp"});
                    });
                }  */
                function handleYes() {
                    window.location.href = "instance_list.jsp?operation=delete&iid="+iid;
                }
                CARBON.showConfirmationDialog("<fmt:message key="do.you.want.to.delete.the.instance"/> "+ iid + "?", handleYes, null);
                return false;
            };

            BPEL.instance.terminateIns = function(iid){
                function handleYes(){
                    window.location.href = "instance_view.jsp?operation=terminate&iid="+iid;
                }
                CARBON.showConfirmationDialog('<fmt:message key="do.you.want.to.terminate.instance"/> ' + iid + '?', handleYes, null);
                return false;
            }

            BPEL.instance.recover = function(iid, aid, action){
                function handleYes(){
                    window.location.href = "instance_view.jsp?operation=recover&iid="+iid+"&aid="+aid+"&action="+action;
                }
                if (action == 'cancel') {
                    CARBON.showConfirmationDialog('<fmt:message key="do.you.want.to.cancel.activity"/> ' + aid + '?', handleYes, null);
                } else if (action == 'retry') {
                    CARBON.showConfirmationDialog('<fmt:message key="do.you.want.to.retry.activity"/> ' + aid + '?', handleYes, null);    
                } else if (action == 'suspended') {
                    CARBON.showInfoDialog('<fmt:message key="cannot.retry.activity"/> ');
                }
                return false;
            }

            BPEL.instance.suspendIns = function(iid){
                function handleYes(){
                    window.location.href = "instance_view.jsp?operation=suspend&iid="+iid;
                }
                CARBON.showConfirmationDialog('<fmt:message key="do.you.want.to.suspend.instance"/> ' + iid + '?', handleYes, null);
                return false;
            }

            BPEL.instance.resumeIns = function(iid){
                function handleYes(){
                    window.location.href = "instance_view.jsp?operation=resume&iid="+iid;
                }
                CARBON.showConfirmationDialog('<fmt:message key="do.you.want.to.resume.instance"/> ' + iid + '?', handleYes, null);
                return false;
            }
            
            jQuery(document).ready(function() {
                BPEL.instance.loadDynamicProps();
                intervalObject = setInterval("BPEL.instance.loadDynamicProps()", 15000);
            });
        </script>
        <h2><fmt:message key="instance"/> <%=iid%> <fmt:message key="details"/></h2>

        <div id="workArea">
        </div>
    </div>
</fmt:bundle>