<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.apache.axiom.om.OMAbstractFactory" %>
<%@ page import="org.apache.axiom.om.OMFactory" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="java.io.PrintWriter" %>
<%@ page import="java.lang.String" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.wso2.carbon.bpel.ui.InstanceManagementServiceClient" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.InstanceInfoListPaginated" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.InstanceInfoType" %>

<%
    response.setHeader("Cache-Control",
            "no-store, max-age=0, no-cache, must-revalidate");

    // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");

    // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");

    InstanceInfoListPaginated instanceList = null;
    int numberOfPages = -1;
    InstanceInfoType instances[] = null;
    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    Log log = LogFactory.getLog("list.instance.ajaxprocessor");
    String filter = (String) session.getAttribute("ifilter");
    String orderBy = (String) session.getAttribute("iorder");

    Integer pageNumber = (Integer) session.getAttribute("ipageNumber");

    InstanceManagementServiceClient client;
    
    try {
        client = new InstanceManagementServiceClient(cookie, backendServerURL, configContext);
    } catch (Exception e) {
        log.error("Instance Management Client Creation Failed. ", e);
        return;
    }

    OMFactory factory = OMAbstractFactory.getOMFactory();
    OMElement root = factory.createOMElement("InstanceList", null);

    while (pageNumber >= 0) {
        try {
            instanceList = client.listInstancesPaginated(filter, orderBy, 300, pageNumber);
        } catch (Exception e) {
            log.error("listInstancesPaginated Operation Failed.", e);
            return;
        }

        if (instanceList != null) {
            numberOfPages = instanceList.getPages();
            if (numberOfPages > 0) {
                instances = instanceList.getInstanceInfo();
                if (instances != null) {
                    for (InstanceInfoType instance : instances) {
                        OMElement instanceEle = factory.createOMElement("Instance", null);
                        OMElement iidEle = factory.createOMElement("iid", null, instanceEle);
                        iidEle.setText(instance.getIid());
                        OMElement pidEle = factory.createOMElement("pid", null, instanceEle);
                        pidEle.setText(instance.getPid());
                        OMElement statusEle = factory.createOMElement("status", null, instanceEle);
                        statusEle.setText(instance.getStatus().getValue());
                        OMElement dateStartedEle = factory.createOMElement("started", null, instanceEle);
                        dateStartedEle.setText(instance.getDateStarted().getTime().toString());
                        OMElement lastActiveDate = factory.createOMElement("lastActive", null, instanceEle);
                        if(instance.getDateLastActive() != null && instance.getDateLastActive().getTime() != null){
                            lastActiveDate.setText(instance.getDateLastActive().getTime().toString());
                        }else{
                            lastActiveDate.setText("");
                        }

                        root.addChild(instanceEle);
                    }
                    OMElement numPagesEle = factory.createOMElement("Pages", null, root);
                    numPagesEle.setText(Integer.toString(numberOfPages));
                    OMElement numPageNumberEle = factory.createOMElement("PageNumber", null, root);
                    numPageNumberEle.setText(Integer.toString(pageNumber));
                    break;
                } else {
                    pageNumber--;
                    session.setAttribute("ipageNumber", pageNumber);
                }
            } else {
                OMElement numPagesEle = factory.createOMElement("Pages", null, root);
                numPagesEle.setText(Integer.toString(numberOfPages));
                break;
            }
        } else {
            break;
        }
    }

    request.setCharacterEncoding("UTF-8");
    // Set content to xml
    response.setContentType("text/xml; charset=UTF-8");         

    PrintWriter pw = response.getWriter();
    pw.write(root.toString());
    pw.flush(); // alles senden!
%>

                            
