<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.wso2.carbon.bpel.ui.ProcessManagementServiceClient" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.ProcessAndInstanceSummary" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.InstanceSummaryType" %>
<%@ page import="org.wso2.carbon.bpel.ui.InstanceManagementServiceClient" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.InstanceInfoListPaginated" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.InstanceInfoType" %>
<%@ page import="java.util.Arrays" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.apache.http.HttpStatus" %>
<%@ page import="java.util.ArrayList" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<fmt:bundle basename="org.wso2.carbon.bpel.ui.i18n.Resources">
<%
    Log log = LogFactory.getLog("summary.ajaxprocessor");
    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    ProcessManagementServiceClient clientP = null;
    InstanceManagementServiceClient clientI = null;
    ProcessAndInstanceSummary pSum = null;
    InstanceSummaryType iSum = null;
    InstanceInfoListPaginated lastActive = null;
    InstanceInfoListPaginated failedSuspendError = null;
    ArrayList<InstanceInfoType> failedSuspendErrorIncetances = new ArrayList<InstanceInfoType>();

    response.setHeader("Cache-Control", "no-cache");
    response.setHeader("Pragma", "no-cache");

    try {
        clientP = new ProcessManagementServiceClient(cookie, backendServerURL, configContext);
    } catch (Exception e) {
        response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
        log.error("Process Management Client creation Failed.", e);
        return;
    }

    try {
        pSum = clientP.getOverallProcessAndInstanceSummary();
        iSum = pSum.getInstances();
    } catch (Exception e) {
        log.error("getOverallProcessAndInstanceSummary Operation Failed.", e);
        response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
        return;
    }

    try {
        clientI = new InstanceManagementServiceClient(cookie, backendServerURL, configContext);
    } catch (Exception e) {
        log.error("Instance Management Client Creation Failed.", e);
        response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
        return;
    }

    try {
        failedSuspendError = clientI.listInstancesPaginated("status=failed|error|suspended", "-last-active", 20, 0);
    } catch (Exception e) {
        log.error("listInstancesPaginated Operation Failed.", e);
        response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
        return;
    }
        if (failedSuspendError != null && failedSuspendError.getInstanceInfo() != null
                && failedSuspendError.getInstanceInfo().length > 0  && failedSuspendError.getInstanceInfo()[0] != null) {
                failedSuspendErrorIncetances.addAll(Arrays.asList(failedSuspendError.getInstanceInfo()));
             if (failedSuspendError.getPages() == 2) {
                 failedSuspendError = clientI.listInstancesPaginated("status=failed|error|suspended", "-last-active", 20, 1);
                 if (failedSuspendError != null && failedSuspendError.getInstanceInfo() != null
                         && failedSuspendError.getInstanceInfo().length > 0  && failedSuspendError.getInstanceInfo()[0] != null) {
                    failedSuspendErrorIncetances.addAll(Arrays.asList(failedSuspendError.getInstanceInfo()));
                 }
             }
        }
     
    try {
        lastActive = clientI.listInstancesPaginated("name}}* namespace=*", "-last-active", 1, 0);
    } catch (Exception e) {
        log.error("listInstancesPaginated Operation Failed.", e);
        response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
        return;
    }
    
    if(clientP != null && pSum != null && iSum != null){
%>

<script type="text/javascript">
    BPEL.summary.drawSummaryGraph = function() {
        function lableFormat(label, data){
            var str = label + ": "+ data[0][1];
            return str;
        }

        var options = {
            yaxis:{tickDecimals:0},
            xaxis:{ticks:[[0, "<fmt:message key="active"/>"],[1, "<fmt:message key="completed"/>"],
                [2, "<fmt:message key="error"/>"], [3, "<fmt:message key="failed"/>"],
                [4, "<fmt:message key="suspended"/>"], [5, "<fmt:message key="terminated"/>"], [6, ""]]},
            bars: { show: true, autoScale: true, fillOpacity: 1 },
            legend:{show:true ,position:"ne",backgroundOpacity:0.4, labelFormatter:lableFormat}
        };

        var dataISet = [{label:"<fmt:message key="active"/>", data:[[0, <%=iSum.getActive()%>]], color:'#C4DF9B'},
            {label:"<fmt:message key="completed"/>", data:[[1, <%=iSum.getCompleted()%>]], color:'#BCDAF3'},
            {label:"<fmt:message key="error"/>", data:[[2, <%=iSum.getError()%>]], color:'#FFEB95'},
            {label:"<fmt:message key="failed"/>", data:[[3, <%=iSum.getFailed()%>]], color:'#E7E7E8'},
            {label:"<fmt:message key="suspended"/>", data:[[4, <%=iSum.getSuspended()%>]], color:'#FDC88A'},
            {label:"<fmt:message key="terminated"/>", data:[[5, <%=iSum.getTerminated()%>]], color:'#F79C7B'}]

        $.plot($("#instanceSummary"), dataISet, options);
    }
</script>
<style type="text/css">
    #instanceSummary {
        width: 400px;
        height: 300px;
        margin-top:10px;
    }
</style>


<table width="100%">
<tr>
    <td width="49%">
        <table class="styledLeft">
            <thead>
                <tr>
                    <th><fmt:message key="instance.summary.graphs"/></th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>
                        <div id="instanceSummary">

                        </div>
                    </td>
                </tr>
            </tbody>
        </table>
    </td>
    <td width="2%"></td>
    <td width="49%">
        <table class="styledLeft" id="engineSummaryTable" style="width:99%">
            <thead>
                <tr>
                    <th colspan="2"><fmt:message key="bpel.engine.summary"/></th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td><span class="icon-text" style="background-image:url(images/bpel-process.gif);"><fmt:message
                            key="total.processes"/></span></td>
                    <td width="8%"><%=pSum.getActiveProcesses() + pSum.getRetiredProcesses()%>
                    </td>
                </tr>
                <tr>
                    <td><span class="icon-text" style="background-image:url(images/bpel-instance.gif);"><fmt:message
                            key="total.instance"/></span></td>
                    <td width="8%"><%=iSum.getActive() + iSum.getCompleted() + iSum.getError() + iSum.getFailed() +
                            iSum.getSuspended() + iSum.getTerminated()%>
                    </td>
                </tr>
            </tbody>
        </table>
        <br/>
        <table class="styledLeft" id="instanceSummaryTable" style="width:99%">
            <thead>
                <tr>
                    <th colspan="2"><fmt:message key="instance.summary"/></th>
                </tr>
            </thead>
            <tbody>

                <tr>
                    <td><span class="icon-text" style="background-image:url(images/bpel-ins-active.gif);"><fmt:message
                            key="active.instaces"/></span></td>
                    <td width="8%"><%=iSum.getActive()%>
                    </td>
                </tr>
                <tr>
                    <td><span class="icon-text" style="background-image:url(images/bpel-ins-completed.gif);"><fmt:message
                            key="completed.instances"/></span></td>
                    <td width="8%"><%=iSum.getCompleted()%>
                    </td>
                </tr>
                <tr>
                    <td><span class="icon-text" style="background-image:url(images/bpel-ins-errors.gif);"><fmt:message
                            key="instances.with.errors"/></span></td>
                    <td width="8%"><%=iSum.getError()%>
                    </td>
                </tr>
                <tr>
                    <td><span class="icon-text" style="background-image:url(images/bpel-ins-failed.gif);"><fmt:message
                            key="failed.instances"/></span></td>
                    <td width="8%"><%=iSum.getFailed()%>
                    </td>
                </tr>
                <tr>
                    <td><span class="icon-text" style="background-image:url(images/bpel-ins-suspended.gif);"><fmt:message
                            key="suspended.instances"/></span></td>
                    <td width="8%"><%=iSum.getSuspended()%>
                    </td>
                </tr>
                <tr>
                    <td><span class="icon-text" style="background-image:url(images/bpel-ins-terminated.gif);"><fmt:message
                            key="terminated.instances"/></span></td>
                    <td width="8%"><%=iSum.getTerminated()%>
                    </td>
                </tr>                
                <%     
                    if (lastActive != null && lastActive.getInstanceInfo() != null && lastActive.getInstanceInfo()[0] != null) {
                %>
                <tr>
                    <td><strong><fmt:message key="last.active.instance"/></strong></td>
                    <td width="8%"><a href="instance_view.jsp?iid=<%=lastActive.getInstanceInfo()[0].getIid()%>"><%=lastActive.getInstanceInfo()[0].getIid()%>
                    </a></td>
                </tr>
                <%
                    }
                %>
            </tbody>
        </table>
    </td>
</tr>
<tr>&nbsp;</tr>
<tr>
    <td width="49%">
        <table class="styledLeft" id="suspendedInstancesTable">
            <thead>
                <th colspan="2"><fmt:message key="suspended.instances"/></th>
            </thead>
            <tbody>
                <%
                    if (failedSuspendErrorIncetances != null && !failedSuspendErrorIncetances.isEmpty()) {
                        int suspended = 0;
                        for (InstanceInfoType inst : failedSuspendErrorIncetances) {
                            if (inst.getStatus().getValue().toUpperCase().equals("SUSPENDED")) {
                                suspended++;
                %>
                <tr>
                    <td><a href="instance_view.jsp?iid=<%=inst.getIid()%>"><%=inst.getIid()%>
                    </a></td>
                    <td><a href="process_view.jsp?pid=<%=inst.getPid()%>"><%=inst.getPid()%>
                    </a></td>
                </tr>
                <%
                            }
                        }
                        if (suspended == 0) {
                %>
                <tr>
                    <td colspan="2"><fmt:message key="no.suspended.instances"/></td>
                </tr>
                <%
                        }
                    } else {
                %>
                <tr>
                    <td colspan="2"><fmt:message key="no.suspended.instances"/></td>
                </tr>
                <%
                    }
               %>
            </tbody>
        </table>
    </td>
    <td width="2%"></td>
    <td width="49%">
        <table class="styledLeft" id="failedInstancesTable" style="width:99%">
            <thead>
                <th colspan="2"><fmt:message key="failed.and.error.instances"/></th>
            </thead>
            <tbody>
                <%
                    int failedError = 0;
                    if (failedSuspendErrorIncetances != null && !failedSuspendErrorIncetances.isEmpty()) {
                            for (InstanceInfoType inst : failedSuspendErrorIncetances) {
                                if (inst.getStatus().getValue().toUpperCase().equals("ERROR") ||
                                        inst.getStatus().getValue().toUpperCase().equals("FAILED")) {
                                    failedError++;
                %>
                <tr>
                    <td><a href="instance_view.jsp?iid=<%=inst.getIid()%>"><%=inst.getIid()%>
                    </a></td>
                    <td><a href="process_view.jsp?pid=<%=inst.getPid()%>"><%=inst.getPid()%>
                    </a></td>
                </tr>
                <%
                            }
                        }
                        if (failedError == 0) {
                %>
                <tr>
                    <td colspan="2"><fmt:message key="no.failed.errors"/></td>
                </tr>
                <%
                        }
                    } else {
                %>
                <tr>
                    <td colspan="2"><fmt:message key="no.failed.errors"/></td>
                </tr>
                <%
                    }
                %>
            </tbody>
        </table>
    </td>
    <td></td>
</tr>
</table>
<%
    }else{
%>
<p>Error occured while getting the summary from back end server.</p>
<%
    }
%>
</fmt:bundle>
